'use strict';

var _dec, _dec2, _dec3, _desc, _value, _class, _class2, _temp;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _tv = require('tv4');

var _tv2 = _interopRequireDefault(_tv);

var _tv4Formats = require('tv4-formats');

var _tv4Formats2 = _interopRequireDefault(_tv4Formats);

var _ValidationError = require('../ValidationError');

var _ValidationError2 = _interopRequireDefault(_ValidationError);

var _hiddenDataGetterSetter = require('../utils/decorators/hiddenDataGetterSetter');

var _hiddenDataGetterSetter2 = _interopRequireDefault(_hiddenDataGetterSetter);

var _splitQueryProps = require('../utils/splitQueryProps');

var _splitQueryProps2 = _interopRequireDefault(_splitQueryProps);

var _classUtils = require('../utils/classUtils');

var _memoize = require('../utils/decorators/memoize');

var _memoize2 = _interopRequireDefault(_memoize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

/**
 * @typedef {Object} ModelOptions
 *
 * @property {boolean} [patch]
 * @property {boolean} [skipValidation]
 */

var ModelBase = (_dec = (0, _hiddenDataGetterSetter2.default)('omitFromJson'), _dec2 = (0, _hiddenDataGetterSetter2.default)('omitFromDatabaseJson'), _dec3 = (0, _hiddenDataGetterSetter2.default)('stashedQueryProps'), (_class = (_temp = _class2 = function () {
  function ModelBase() {
    (0, _classCallCheck3.default)(this, ModelBase);
  }

  (0, _createClass3.default)(ModelBase, [{
    key: '$beforeValidate',

    /**
     * @param {Object} jsonSchema
     * @param {Object} json
     * @param {ModelOptions=} options
     * @return {Object}
     */
    value: function $beforeValidate(jsonSchema, json, options) {
      /* istanbul ignore next */
      return jsonSchema;
    }

    /**
     * @throws {ValidationError}
     * @param {Object=} json
     * @param {ModelOptions=} options
     * @return {Object}
     */

    /**
     * @type {Object}
     */

  }, {
    key: '$validate',
    value: function $validate() {
      var json = arguments.length <= 0 || arguments[0] === undefined ? this : arguments[0];
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      var ModelClass = this.constructor;
      var jsonSchema = ModelClass.jsonSchema;

      if (!jsonSchema || options.skipValidation) {
        return json;
      }

      // No need to call $beforeValidate (and clone the jsonSchema) if $beforeValidate has not been overwritten.
      if (this.$beforeValidate !== ModelBase.prototype.$beforeValidate) {
        jsonSchema = _lodash2.default.cloneDeep(jsonSchema);
        jsonSchema = this.$beforeValidate(jsonSchema, json, options);
      }

      var report = tryValidate(jsonSchema, json, options);
      var validationError = parseValidationError(report);

      if (validationError) {
        throw validationError;
      }

      this.$afterValidate(json, options);
      return json;
    }

    /**
     * @param {Object=} json
     * @param {ModelOptions=} options
     */

  }, {
    key: '$afterValidate',
    value: function $afterValidate(json, options) {}
    // Do nothing by default.

    /**
     * @param {Object} json
     * @return {Object}
     */

  }, {
    key: '$parseDatabaseJson',
    value: function $parseDatabaseJson(json) {
      return json;
    }

    /**
     * @param {Object} json
     * @return {Object}
     */

  }, {
    key: '$formatDatabaseJson',
    value: function $formatDatabaseJson(json) {
      return json;
    }

    /**
     * @param {Object} json
     * @param {ModelOptions=} options
     * @return {Object}
     */

  }, {
    key: '$parseJson',
    value: function $parseJson(json, options) {
      return json;
    }

    /**
     * @param {Object} json
     * @return {Object}
     */

  }, {
    key: '$formatJson',
    value: function $formatJson(json) {
      return json;
    }

    /**
     * @return {Object}
     */

  }, {
    key: '$toDatabaseJson',
    value: function $toDatabaseJson() {
      return this.$$toJson(true, null, null);
    }

    /**
     * @return {Object}
     */

  }, {
    key: '$toJson',
    value: function $toJson() {
      return this.$$toJson(false, null, null);
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      return this.$toJson();
    }

    /**
     * @param {Object} json
     * @param {ModelOptions=} options
     * @returns {ModelBase}
     * @throws ValidationError
     */

  }, {
    key: '$setJson',
    value: function $setJson(json) {
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      json = json || {};

      if (!_lodash2.default.isObject(json) || _lodash2.default.isString(json) || _lodash2.default.isNumber(json) || _lodash2.default.isDate(json) || _lodash2.default.isArray(json) || _lodash2.default.isFunction(json) || _lodash2.default.isTypedArray(json) || _lodash2.default.isRegExp(json)) {

        throw new Error('You should only pass objects to $setJson method. ' + '$setJson method was given an invalid value ' + json);
      }

      if (!options.patch) {
        json = mergeWithDefaults(this.constructor.jsonSchema, json);
      }

      // If the json contains query properties like, knex Raw queries or knex/objection query
      // builders, we need to split those off into a separate object. This object will be
      // joined back in the $toDatabaseJson method.
      var split = (0, _splitQueryProps2.default)(this.constructor, json);

      if (split.query) {
        // Stash the query properties for later use in $toDatabaseJson method.
        this.$stashedQueryProps(split.query);
      }

      split.json = this.$parseJson(split.json, options);
      split.json = this.$validate(split.json, options);

      return this.$set(split.json);
    }

    /**
     * @param {Object} json
     * @returns {ModelBase}
     */

  }, {
    key: '$setDatabaseJson',
    value: function $setDatabaseJson() {
      var json = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      json = this.$parseDatabaseJson(json);

      for (var key in json) {
        this[key] = json[key];
      }

      return this;
    }

    /**
     * @param {Object} obj
     * @returns {ModelBase}
     */

  }, {
    key: '$set',
    value: function $set(obj) {
      var self = this;

      _lodash2.default.each(obj, function (value, key) {
        if (key.charAt(0) !== '$' && !_lodash2.default.isFunction(value)) {
          self[key] = value;
        }
      });

      return this;
    }

    /**
     * @param {Array.<string>=} keys
     * @returns {Array.<string>}
     */

  }, {
    key: '$omitFromJson',
    value: function $omitFromJson(keys) {}

    /**
     * @param {Array.<string>=} keys
     * @returns {Array.<string>}
     */

  }, {
    key: '$omitFromDatabaseJson',
    value: function $omitFromDatabaseJson(keys) {}

    /**
     * @param {Object=} queryProps
     * @returns {Object}
     */

  }, {
    key: '$stashedQueryProps',
    value: function $stashedQueryProps(queryProps) {}

    /**
     * @param {string|Array.<string>|Object.<string, boolean>} keys
     * @returns {ModelBase}
     */

  }, {
    key: '$omit',
    value: function $omit() {
      if (arguments.length === 1 && _lodash2.default.isObject(arguments[0])) {
        var keys = arguments[0];

        if (_lodash2.default.isArray(keys)) {
          omitArray(this, keys);
        } else {
          omitObject(this, keys);
        }
      } else {
        omitArray(this, _lodash2.default.toArray(arguments));
      }

      return this;
    }

    /**
     * @param {string|Array.<string>|Object.<string, boolean>} keys
     * @returns {ModelBase} `this` for chaining.
     */

  }, {
    key: '$pick',
    value: function $pick() {
      if (arguments.length === 1 && _lodash2.default.isObject(arguments[0])) {
        var keys = arguments[0];

        if (_lodash2.default.isArray(keys)) {
          pickArray(this, keys);
        } else {
          pickObject(this, keys);
        }
      } else {
        pickArray(this, _lodash2.default.toArray(arguments));
      }

      return this;
    }

    /**
     * @param {Array.<string>} props
     * @return {Array.<*>}
     */

  }, {
    key: '$values',
    value: function $values() {
      var _this = this;

      if (arguments.length === 0) {
        return _lodash2.default.values(this);
      } else if (arguments.length === 1 && _lodash2.default.isArray(arguments[0])) {
        return _lodash2.default.map(arguments[0], function (prop) {
          return _this[prop];
        });
      } else {
        return _lodash2.default.map(arguments, function (prop) {
          return _this[prop];
        });
      }
    }

    /**
     * @return {ModelBase}
     */

  }, {
    key: '$clone',
    value: function $clone() {
      var clone = new this.constructor();

      _lodash2.default.each(this, function (value, key) {
        if (_lodash2.default.isObject(value)) {
          clone[key] = cloneObject(value);
        } else {
          clone[key] = value;
        }
      });

      return clone;
    }

    /**
     * @protected
     */

  }, {
    key: '$$toJson',
    value: function $$toJson(createDbJson, omit, pick) {
      var json = toJsonImpl(this, createDbJson, omit, pick);

      if (createDbJson) {
        return this.$formatDatabaseJson(json);
      } else {
        return this.$formatJson(json);
      }
    }

    /**
     * @param {function=} subclassConstructor
     * @return {Constructor.<ModelBase>}
     */

  }], [{
    key: 'extend',
    value: function extend(subclassConstructor) {
      if (_lodash2.default.isEmpty(subclassConstructor.name)) {
        throw new Error('Each ModelBase subclass constructor must have a name');
      }

      (0, _classUtils.inherits)(subclassConstructor, this);
      return subclassConstructor;
    }

    /**
     * @param {Object=} json
     * @param {ModelOptions=} options
     * @returns {Model}
     * @throws ValidationError
     */

  }, {
    key: 'fromJson',
    value: function fromJson(json, options) {
      var model = new this();
      model.$setJson(json || {}, options);
      return model;
    }

    /**
     * @param {Object=} json
     * @returns {Model}
     */

  }, {
    key: 'fromDatabaseJson',
    value: function fromDatabaseJson(json) {
      var model = new this();
      model.$setDatabaseJson(json || {});
      return model;
    }

    /**
     * @param {Object} obj
     * @param {string} prop
     */

  }, {
    key: 'omitImpl',
    value: function omitImpl(obj, prop) {
      obj[prop] = undefined;
    }

    /**
     * @param {string} columnName
     * @returns {string}
     */

  }, {
    key: 'columnNameToPropertyName',
    value: function columnNameToPropertyName(columnName) {
      var model = new this();
      var addedProps = _lodash2.default.keys(model.$parseDatabaseJson({}));

      var row = {};
      row[columnName] = null;

      var props = _lodash2.default.keys(_lodash2.default.omit(model.$parseDatabaseJson(row), addedProps));
      var propertyName = _lodash2.default.first(props);

      return propertyName || null;
    }

    /**
     * @param {string} propertyName
     * @returns {string}
     */

  }, {
    key: 'propertyNameToColumnName',
    value: function propertyNameToColumnName(propertyName) {
      var model = new this();
      var addedCols = _lodash2.default.keys(model.$formatDatabaseJson({}));

      var obj = {};
      obj[propertyName] = null;

      var cols = _lodash2.default.keys(_lodash2.default.omit(model.$formatDatabaseJson(obj), addedCols));
      var columnName = _lodash2.default.first(cols);

      return columnName || null;
    }
  }]);
  return ModelBase;
}(), _class2.jsonSchema = null, _temp), (_applyDecoratedDescriptor(_class.prototype, '$omitFromJson', [_dec], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, '$omitFromJson'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '$omitFromDatabaseJson', [_dec2], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, '$omitFromDatabaseJson'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '$stashedQueryProps', [_dec3], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, '$stashedQueryProps'), _class.prototype), _applyDecoratedDescriptor(_class, 'columnNameToPropertyName', [_memoize2.default], (0, _getOwnPropertyDescriptor2.default)(_class, 'columnNameToPropertyName'), _class), _applyDecoratedDescriptor(_class, 'propertyNameToColumnName', [_memoize2.default], (0, _getOwnPropertyDescriptor2.default)(_class, 'propertyNameToColumnName'), _class)), _class));
exports.default = ModelBase;

function mergeWithDefaults(jsonSchema, json) {
  var merged = null;

  if (!jsonSchema) {
    return json;
  }

  // Check each schema property for default value.
  for (var key in jsonSchema.properties) {
    var prop = jsonSchema.properties[key];

    if (!_lodash2.default.has(json, key) && _lodash2.default.has(prop, 'default')) {
      if (merged === null) {
        // Only take expensive clone if needed.
        merged = _lodash2.default.cloneDeep(json);
      }

      if (_lodash2.default.isObject(prop.default)) {
        merged[key] = _lodash2.default.cloneDeep(prop.default);
      } else {
        merged[key] = prop.default;
      }
    }
  }

  if (merged === null) {
    return json;
  } else {
    return merged;
  }
}

function tryValidate(jsonSchema, json, options) {
  var required = undefined;

  try {
    if (options.patch) {
      required = jsonSchema.required;
      jsonSchema.required = [];
    }

    return _tv2.default.validateMultiple(json, jsonSchema);
  } finally {
    if (options.patch) {
      jsonSchema.required = required;
    }
  }
}

function parseValidationError(report) {
  var errorHash = {};
  var index = 0;

  if (report.errors.length === 0) {
    return null;
  }

  for (var i = 0; i < report.errors.length; ++i) {
    var error = report.errors[i];
    var key = error.dataPath.split('/').slice(1).join('.');

    // Hack: The dataPath is empty for failed 'required' validations. We parse
    // the property name from the error message.
    if (!key && error.message.substring(0, 26) === 'Missing required property:') {
      key = error.message.split(':')[1].trim();
    }

    // If the validation failed because of extra properties, the key is an empty string. We
    // still want a unique error in the hash for each failure.
    if (!key) {
      key = (index++).toString();
    }

    errorHash[key] = error.message;
  }

  return new _ValidationError2.default(errorHash);
}

function toJsonImpl(model, createDbJson, omit, pick) {
  var json = {};

  var omitFromJson = createDbJson ? model.$omitFromDatabaseJson() : model.$omitFromJson();

  if (createDbJson) {
    // If creating a database json object, restore the query properties.
    _lodash2.default.each(model.$stashedQueryProps(), function (query, key) {
      json[key] = query;
    });
  }

  _lodash2.default.each(model, function (value, key) {
    if (key.charAt(0) !== '$' && !_lodash2.default.isFunction(value) && !_lodash2.default.isUndefined(value) && (!omit || !omit[key]) && (!pick || pick[key]) && (!omitFromJson || !contains(omitFromJson, key))) {

      if (_lodash2.default.isObject(value)) {
        json[key] = toJsonObject(value, createDbJson);
      } else {
        json[key] = value;
      }
    }
  });

  return json;
}

function toJsonObject(value, createDbJson) {
  if (_lodash2.default.isArray(value)) {
    return toJsonArray(value, createDbJson);
  } else if (value instanceof ModelBase) {
    if (createDbJson) {
      return value.$toDatabaseJson();
    } else {
      return value.$toJson();
    }
  } else if (Buffer.isBuffer(value)) {
    return value;
  } else {
    return _lodash2.default.cloneDeep(value);
  }
}

function toJsonArray(value, createDbJson) {
  return _lodash2.default.map(value, function (value) {
    return toJsonObject(value, createDbJson);
  });
}

function cloneObject(value) {
  if (_lodash2.default.isArray(value)) {
    return cloneArray(value);
  } else if (value instanceof ModelBase) {
    return value.$clone();
  } else if (Buffer.isBuffer(value)) {
    return new Buffer(value);
  } else {
    return _lodash2.default.cloneDeep(value);
  }
}

function cloneArray(value) {
  return _lodash2.default.map(value, cloneObject);
}

function omitObject(model, keyObj) {
  var ModelClass = model.constructor;

  _lodash2.default.each(keyObj, function (value, key) {
    if (value && key.charAt(0) !== '$' && _lodash2.default.has(model, key)) {
      ModelClass.omitImpl(model, key);
    }
  });
}

function omitArray(model, keys) {
  var ModelClass = model.constructor;

  _lodash2.default.each(keys, function (key) {
    if (key.charAt(0) !== '$' && _lodash2.default.has(model, key)) {
      ModelClass.omitImpl(model, key);
    }
  });
}

function pickObject(model, keyObj) {
  var ModelClass = model.constructor;

  _lodash2.default.each(model, function (value, key) {
    if (key.charAt(0) !== '$' && !keyObj[key]) {
      ModelClass.omitImpl(model, key);
    }
  });
}

function pickArray(model, keys) {
  var ModelClass = model.constructor;

  _lodash2.default.each(model, function (value, key) {
    if (key.charAt(0) !== '$' && !contains(keys, key)) {
      ModelClass.omitImpl(model, key);
    }
  });
}

function contains(arr, value) {
  for (var i = 0, l = arr.length; i < l; ++i) {
    if (arr[i] === value) {
      return true;
    }
  }
  return false;
}

// Add validation formats, so that for example the following schema validation works:
// createTime: {type: 'string', format: 'date-time'}
_tv2.default.addFormat(_tv4Formats2.default);