'use strict';

var _dec, _desc, _value, _class;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get3 = require('babel-runtime/helpers/get');

var _get4 = _interopRequireDefault(_get3);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _RelationExpression = require('./RelationExpression');

var _RelationExpression2 = _interopRequireDefault(_RelationExpression);

var _InsertionOrUpdate = require('./InsertionOrUpdate');

var _InsertionOrUpdate2 = _interopRequireDefault(_InsertionOrUpdate);

var _InsertWithRelated = require('./InsertWithRelated');

var _InsertWithRelated2 = _interopRequireDefault(_InsertWithRelated);

var _QueryBuilderBase2 = require('./QueryBuilderBase');

var _QueryBuilderBase3 = _interopRequireDefault(_QueryBuilderBase2);

var _ValidationError = require('../ValidationError');

var _ValidationError2 = _interopRequireDefault(_ValidationError);

var _EagerFetcher = require('./EagerFetcher');

var _EagerFetcher2 = _interopRequireDefault(_EagerFetcher);

var _dbUtils = require('../utils/dbUtils');

var _deprecated = require('../utils/decorators/deprecated');

var _deprecated2 = _interopRequireDefault(_deprecated);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var QueryBuilder = (_dec = (0, _deprecated2.default)({ removedIn: '0.6.0', useInstead: 'debug()' }), (_class = function (_QueryBuilderBase) {
  (0, _inherits3.default)(QueryBuilder, _QueryBuilderBase);

  function QueryBuilder(modelClass) {
    (0, _classCallCheck3.default)(this, QueryBuilder);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(QueryBuilder).call(this, modelClass.knex()));

    _this._modelClass = modelClass;
    _this._calledWriteMethod = null;
    _this._explicitRejectValue = null;
    _this._explicitResolveValue = null;

    _this._hooks = null;
    _this._customImpl = null;

    _this._eagerExpression = null;
    _this._eagerFilters = null;
    _this._eagerFilterExpressions = [];
    _this._allowedEagerExpression = null;
    _this._allowedInsertExpression = null;

    _this.internalContext().runBefore = [];
    _this.internalContext().runAfter = [];
    _this.internalContext().onBuild = [];

    _this.clearHooks();
    _this.clearCustomImpl();
    return _this;
  }

  /**
   * @param {Model} modelClass
   * @returns {QueryBuilder}
   */

  (0, _createClass3.default)(QueryBuilder, [{
    key: 'context',

    /**
     * @param {Object=} ctx
     * @returns {QueryBuilder|Object}
     */
    value: function context() {
      var _get2;

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      // This implementation is here just so that we can document it.
      return (_get2 = (0, _get4.default)((0, _getPrototypeOf2.default)(QueryBuilder.prototype), 'context', this)).call.apply(_get2, [this].concat(args));
    }

    /**
     * @param {QueryBuilderBase} query
     */

  }, {
    key: 'childQueryOf',
    value: function childQueryOf(query) {
      if (query) {
        this.internalContext(query.internalContext());

        if (query.has(/debug/)) {
          this.debug();
        }
      }
      return this;
    }

    /**
     * @param {Error} error
     * @returns {QueryBuilder}
     */

  }, {
    key: 'reject',
    value: function reject(error) {
      this._explicitRejectValue = error;
      return this;
    }

    /**
     * @param {*} value
     * @returns {QueryBuilder}
     */

  }, {
    key: 'resolve',
    value: function resolve(value) {
      this._explicitResolveValue = value;
      return this;
    }

    /**
     * @returns {boolean}
     */

  }, {
    key: 'isExecutable',
    value: function isExecutable() {
      return !this._explicitRejectValue && !this._explicitResolveValue && !this._hooks.executor;
    }

    /**
     * @param {function(*, QueryBuilder)} runBefore
     * @returns {QueryBuilder}
     */

  }, {
    key: 'runBefore',
    value: function runBefore(_runBefore) {
      this._hooks.before.push(_runBefore);
      return this;
    }

    /**
     * @param {function(*, QueryBuilder)} runBefore
     * @returns {QueryBuilder}
     */

  }, {
    key: 'runBeforePushFront',
    value: function runBeforePushFront(runBefore) {
      this._hooks.before.unshift(runBefore);
      return this;
    }

    /**
     * @param {function(QueryBuilder)} onBuild
     * @returns {QueryBuilder}
     */

  }, {
    key: 'onBuild',
    value: function onBuild(_onBuild) {
      this._hooks.onBuild.push(_onBuild);
      return this;
    }

    /**
     * @param {function(QueryBuilder)} executor
     * @returns {QueryBuilder}
     */

  }, {
    key: 'setQueryExecutor',
    value: function setQueryExecutor(executor) {
      if (this._hooks.executor) {
        throw Error('overwriting an executor. you should not do this.');
      }

      this._hooks.executor = executor;
      return this;
    }

    /**
     * @param {function(Model|Array.<Model>, QueryBuilder)} runAfterModelCreate
     * @returns {QueryBuilder}
     */

  }, {
    key: 'runAfterModelCreate',
    value: function runAfterModelCreate(_runAfterModelCreate) {
      this._hooks.afterModelCreate.push(_runAfterModelCreate);
      return this;
    }

    /**
     * @param {function(Model|Array.<Model>, QueryBuilder)} runAfterModelCreate
     * @returns {QueryBuilder}
     */

  }, {
    key: 'runAfterModelCreatePushFront',
    value: function runAfterModelCreatePushFront(runAfterModelCreate) {
      this._hooks.afterModelCreate.unshift(runAfterModelCreate);
      return this;
    }

    /**
     * @param {function(Model|Array.<Model>, QueryBuilder)} runAfter
     * @returns {QueryBuilder}
     */

  }, {
    key: 'runAfter',
    value: function runAfter(_runAfter) {
      this._hooks.after.push(_runAfter);
      return this;
    }

    /**
     * @param {function(Model|Array.<Model>, QueryBuilder)} runAfter
     * @returns {QueryBuilder}
     */

  }, {
    key: 'runAfterPushFront',
    value: function runAfterPushFront(runAfter) {
      this._hooks.after.unshift(runAfter);
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'findImpl',
    value: function findImpl(_findImpl) {
      this._customImpl.find = _findImpl || null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'insertImpl',
    value: function insertImpl(_insertImpl) {
      this._customImpl.insert = _insertImpl || null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'updateImpl',
    value: function updateImpl(_updateImpl) {
      this._customImpl.update = _updateImpl || null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'patchImpl',
    value: function patchImpl(_patchImpl) {
      this._customImpl.patch = _patchImpl || null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'deleteImpl',
    value: function deleteImpl(_deleteImpl) {
      this._customImpl.delete = _deleteImpl || null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'relateImpl',
    value: function relateImpl(_relateImpl) {
      this._customImpl.relate = _relateImpl || null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'unrelateImpl',
    value: function unrelateImpl(_unrelateImpl) {
      this._customImpl.unrelate = _unrelateImpl || null;
      return this;
    }

    /**
     * @param {string|RelationExpression} exp
     * @param {Object.<string, function(QueryBuilder)>=} filters
     * @returns {QueryBuilder}
     */

  }, {
    key: 'eager',
    value: function eager(exp, filters) {
      this._eagerExpression = exp || null;
      this._eagerFilters = filters || null;

      if (_lodash2.default.isString(this._eagerExpression)) {
        this._eagerExpression = _RelationExpression2.default.parse(this._eagerExpression);
      }

      checkEager(this);
      return this;
    }

    /**
     * @param {string|RelationExpression} exp
     * @returns {QueryBuilder}
     */

  }, {
    key: 'allowEager',
    value: function allowEager(exp) {
      this._allowedEagerExpression = exp || null;

      if (_lodash2.default.isString(this._allowedEagerExpression)) {
        this._allowedEagerExpression = _RelationExpression2.default.parse(this._allowedEagerExpression);
      }

      checkEager(this);
      return this;
    }

    /**
     * @param {string|RelationExpression} path
     * @param {function(QueryBuilder)} filter
     * @returns {QueryBuilder}
     */

  }, {
    key: 'filterEager',
    value: function filterEager(path, filter) {
      this._eagerFilterExpressions.push({
        path: path,
        filter: filter
      });

      return this;
    }

    /**
     * @param {string|RelationExpression} exp
     * @returns {QueryBuilder}
     */

  }, {
    key: 'allowInsert',
    value: function allowInsert(exp) {
      this._allowedInsertExpression = exp || null;

      if (_lodash2.default.isString(this._allowedInsertExpression)) {
        this._allowedInsertExpression = _RelationExpression2.default.parse(this._allowedInsertExpression);
      }

      return this;
    }

    /**
     * @returns {Model}
     */

  }, {
    key: 'modelClass',
    value: function modelClass() {
      return this._modelClass;
    }

    /**
     * @returns {boolean}
     */

  }, {
    key: 'isFindQuery',
    value: function isFindQuery() {
      return !this._calledWriteMethod && !this.has(/insert|update|delete/);
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'toString',
    value: function toString() {
      return this.build().toString();
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'toSql',
    value: function toSql() {
      return this.toString();
    }

    /**
     * @param {function(string)=} logger
     * @returns {QueryBuilder}
     */

  }, {
    key: 'dumpSql',
    value: function dumpSql(logger) {
      (logger || console.log)(this.toString());
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clone',
    value: function clone() {
      var builder = new this.constructor(this._modelClass);
      // This is a QueryBuilderBase method.
      this.cloneInto(builder);

      var builderIntCtx = builder.internalContext();
      var intCtx = this.internalContext();

      builderIntCtx.runBefore = intCtx.runBefore.slice();
      builderIntCtx.runAfter = intCtx.runAfter.slice();
      builderIntCtx.onBuild = intCtx.onBuild.slice();

      builder._calledWriteMethod = this._calledWriteMethod;
      builder._explicitRejectValue = this._explicitRejectValue;
      builder._explicitResolveValue = this._explicitResolveValue;

      _lodash2.default.forEach(this._hooks, function (funcs, key) {
        builder._hooks[key] = _lodash2.default.isArray(funcs) ? funcs.slice() : funcs;
      });

      _lodash2.default.forEach(this._customImpl, function (impl, key) {
        builder._customImpl[key] = impl;
      });

      builder._eagerExpression = this._eagerExpression;
      builder._eagerFilters = this._eagerFilters;
      builder._eagerFilterExpressions = this._eagerFilterExpressions.slice();
      builder._allowedEagerExpression = this._allowedEagerExpression;
      builder._allowedInsertExpression = this._allowedInsertExpression;

      return builder;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clearCustomImpl',
    value: function clearCustomImpl() {
      this._customImpl = {
        find: function find() {},
        relate: function relate() {},
        unrelate: function unrelate() {},
        insert: function insert(_insert, builder) {
          builder.onBuild(function (builder) {
            builder.$$insert(_insert);
          });
        },
        update: function update(_update, builder) {
          builder.onBuild(function (builder) {
            builder.$$update(_update);
          });
        },
        patch: function patch(_patch, builder) {
          builder.onBuild(function (builder) {
            builder.$$update(_patch);
          });
        },
        delete: function _delete(builder) {
          builder.onBuild(function (builder) {
            builder.$$delete();
          });
        }
      };

      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clearHooks',
    value: function clearHooks() {
      this._hooks = {
        before: [],
        onBuild: [],
        executor: null,
        afterModelCreate: [],
        after: []
      };

      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clearEager',
    value: function clearEager() {
      this._eagerExpression = null;
      this._eagerFilters = null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clearReject',
    value: function clearReject() {
      this._explicitRejectValue = null;
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clearResolve',
    value: function clearResolve() {
      this._explicitResolveValue = null;
      return this;
    }

    /**
     * @param {RegExp=} regex
     * @returns {QueryBuilder}
     */

  }, {
    key: 'clear',
    value: function clear(regex) {
      (0, _get4.default)((0, _getPrototypeOf2.default)(QueryBuilder.prototype), 'clear', this).call(this, regex);

      if (regex) {
        // Clear the write method call also if it doesn't pass the filter.
        if (regex.test(this._calledWriteMethod)) {
          this._calledWriteMethod = null;
        }
      } else {
        this._calledWriteMethod = null;
      }

      return this;
    }

    /**
     * @param {RegExp} methodNameRegex
     * @returns {boolean}
     */

  }, {
    key: 'has',
    value: function has(methodNameRegex) {
      return (0, _get4.default)((0, _getPrototypeOf2.default)(QueryBuilder.prototype), 'has', this).call(this, methodNameRegex) || methodNameRegex.test(this._calledWriteMethod);
    }

    /**
     * @param {function=} successHandler
     * @param {function=} errorHandler
     * @returns {Promise}
     */

  }, {
    key: 'then',
    value: function then() {
      var promise = this._execute();
      return promise.then.apply(promise, arguments);
    }

    /**
     * @param {function} mapper
     * @returns {Promise}
     */

  }, {
    key: 'map',
    value: function map() {
      var promise = this._execute();
      return promise.map.apply(promise, arguments);
    }

    /**
     * @param {function} errorHandler
     * @returns {Promise}
     */

  }, {
    key: 'catch',
    value: function _catch() {
      var promise = this._execute();
      return promise.catch.apply(promise, arguments);
    }

    /**
     * @param {*} returnValue
     * @returns {Promise}
     */

  }, {
    key: 'return',
    value: function _return() {
      var promise = this._execute();
      return promise.return.apply(promise, arguments);
    }

    /**
     * @param {*} context
     * @returns {Promise}
     */

  }, {
    key: 'bind',
    value: function bind() {
      var promise = this._execute();
      return promise.bind.apply(promise, arguments);
    }

    /**
     * @param {function} callback
     * @returns {Promise}
     */

  }, {
    key: 'asCallback',
    value: function asCallback() {
      var promise = this._execute();
      return promise.asCallback.apply(promise, arguments);
    }

    /**
     * @param {function} callback
     * @returns {Promise}
     */

  }, {
    key: 'nodeify',
    value: function nodeify() /*callback*/{
      var promise = this._execute();
      return promise.nodeify.apply(promise, arguments);
    }

    /**
     * @returns {Promise}
     */

  }, {
    key: 'resultSize',
    value: function resultSize() {
      var knex = this._modelClass.knex();

      // orderBy is useless here and it can make things a lot slower (at least with postgresql 9.3).
      // Remove it from the count query. We also remove the offset and limit
      var query = this.clone().clear(/orderBy|offset|limit/).build();
      var rawQuery = knex.raw(query).wrap('(', ') as temp');
      var countQuery = knex.count('* as count').from(rawQuery);

      return countQuery.then(function (result) {
        return result[0] ? result[0].count : 0;
      });
    }

    /**
     * @param {number} page
     * @param {number} pageSize
     * @returns {QueryBuilder}
     */

  }, {
    key: 'page',
    value: function page(_page, pageSize) {
      return this.range(_page * pageSize, (_page + 1) * pageSize - 1);
    }

    /**
     * @param {number} start
     * @param {number} end
     * @returns {QueryBuilder}
     */

  }, {
    key: 'range',
    value: function range(start, end) {
      var self = this;
      var resultSizePromise = undefined;

      return this.limit(end - start + 1).offset(start).runBefore(function () {
        // Don't return the promise so that it is executed
        // in parallel with the actual query.
        resultSizePromise = self.resultSize();
      }).runAfter(function (results) {
        // Now that the actual query is finished, wait until the
        // result size has been calculated.
        return _bluebird2.default.all([results, resultSizePromise]);
      }).runAfter(function (arr) {
        return {
          results: arr[0],
          total: _lodash2.default.parseInt(arr[1])
        };
      });
    }
  }, {
    key: 'build',

    /**
     * @returns {knex.QueryBuilder}
     */
    value: function build() {
      var builder = this.clone();

      if (builder.isFindQuery()) {
        // If no write methods have been called at this point this query is a
        // find query and we need to call the custom find implementation.
        builder._customImpl.find.call(builder, builder);
      }

      // We need to build the builder even if the _hooks.executor function
      // has been defined so that the onBuild hooks get called.
      var knexBuilder = _build(builder);

      if (_lodash2.default.isFunction(builder._hooks.executor)) {
        // If the query executor is set, we build the builder that it returns.
        return builder._hooks.executor.call(builder, builder).build();
      } else {
        return knexBuilder;
      }
    }

    /**
     * @returns {Promise}
     */

  }, {
    key: '_execute',
    value: function _execute() {
      // Take a clone so that we don't modify this instance during execution.
      // The hooks and onBuild callbacks usually modify the query and we want
      // this builder to be re-executable.
      var builder = this.clone();
      var promise = _bluebird2.default.resolve();
      var context = builder.context() || {};
      var internalContext = builder.internalContext();

      if (builder.isFindQuery()) {
        // If no write methods have been called at this point this query is a
        // find query and we need to call the custom find implementation.
        builder._customImpl.find.call(builder, builder);
      }

      promise = chainBuilderFuncs(promise, builder, context.runBefore);
      promise = chainBuilderFuncs(promise, builder, internalContext.runBefore);
      promise = chainBuilderFuncs(promise, builder, builder._hooks.before);

      // Resolve all before hooks before building and executing the query
      // and the rest of the hooks.
      return promise.then(function () {
        // We need to build the builder even if the _explicit(Resolve|Reject)Value or _hooks.executor
        // has been defined so that the onBuild hooks get called.
        var knexBuilder = _build(builder);
        var promise = undefined;

        if (builder._explicitResolveValue) {
          promise = _bluebird2.default.resolve(builder._explicitResolveValue);
        } else if (builder._explicitRejectValue) {
          promise = _bluebird2.default.reject(builder._explicitRejectValue);
        } else if (_lodash2.default.isFunction(builder._hooks.executor)) {
          promise = builder._hooks.executor.call(builder, builder);
        } else {
          promise = knexBuilder.then(function (result) {
            return createModels(builder, result);
          });
        }

        promise = chainBuilderFuncs(promise, builder, builder._hooks.afterModelCreate);

        if (builder._eagerExpression) {
          promise = promise.then(function (models) {
            return eagerFetch(builder, models);
          });
        }

        promise = chainBuilderFuncs(promise, builder, context.runAfter);
        promise = chainBuilderFuncs(promise, builder, internalContext.runAfter);
        promise = chainBuilderFuncs(promise, builder, builder._hooks.after);

        return promise;
      });
    }

    /**
     * @param {string} propertyName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'pluck',
    value: function pluck(propertyName) {
      return this.runAfter(function (result) {
        if (_lodash2.default.isArray(result)) {
          return _lodash2.default.pluck(result, propertyName);
        } else {
          return result;
        }
      });
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'first',
    value: function first() {
      return this.runAfter(function (result) {
        if (_lodash2.default.isArray(result)) {
          return result[0];
        } else {
          return result;
        }
      });
    }

    /**
     * @param {Constructor.<Model>=} modelClass
     * @param {function(Model, Model, string)} traverser
     * @returns {QueryBuilder}
     */

  }, {
    key: 'traverse',
    value: function traverse(modelClass, traverser) {
      var self = this;

      if (_lodash2.default.isUndefined(traverser)) {
        traverser = modelClass;
        modelClass = null;
      }

      return this.runAfter(function (result) {
        self._modelClass.traverse(modelClass, result, traverser);
        return result;
      });
    }

    /**
     * @param {Constructor.<Model>=} modelClass
     * @param {Array.<string>} properties
     * @returns {QueryBuilder}
     */

  }, {
    key: 'pick',
    value: function pick(modelClass, properties) {
      if (_lodash2.default.isUndefined(properties)) {
        properties = modelClass;
        modelClass = null;
      }

      properties = _lodash2.default.reduce(properties, function (obj, prop) {
        obj[prop] = true;
        return obj;
      }, {});

      return this.traverse(modelClass, function (model) {
        model.$pick(properties);
      });
    }

    /**
     * @param {Constructor.<Model>=} modelClass
     * @param {Array.<string>} properties
     * @returns {QueryBuilder}
     */

  }, {
    key: 'omit',
    value: function omit(modelClass, properties) {
      if (_lodash2.default.isUndefined(properties)) {
        properties = modelClass;
        modelClass = null;
      }

      // Turn the properties into a hash for performance.
      properties = _lodash2.default.reduce(properties, function (obj, prop) {
        obj[prop] = true;
        return obj;
      }, {});

      return this.traverse(modelClass, function (model) {
        model.$omit(properties);
      });
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'joinRelation',
    value: function joinRelation(relationName) {
      return this.$$joinRelation(relationName, 'join');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'innerJoinRelation',
    value: function innerJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'innerJoin');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'outerJoinRelation',
    value: function outerJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'outerJoin');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'leftJoinRelation',
    value: function leftJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'leftJoin');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'leftOuterJoinRelation',
    value: function leftOuterJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'leftOuterJoin');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'rightJoinRelation',
    value: function rightJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'rightJoin');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'rightOuterJoinRelation',
    value: function rightOuterJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'rightOuterJoin');
    }

    /**
     * @param {string} relationName
     * @returns {QueryBuilder}
     */

  }, {
    key: 'fullOuterJoinRelation',
    value: function fullOuterJoinRelation(relationName) {
      return this.$$joinRelation(relationName, 'fullOuterJoin');
    }

    /**
     * @private
     */

  }, {
    key: '$$joinRelation',
    value: function $$joinRelation(relationName, joinMethod) {
      var relation = this._modelClass.getRelation(relationName);
      relation.join(this, joinMethod, relation.name);
      return this;
    }

    /**
     * @param {string|number|Array.<string|number>} id
     * @returns {QueryBuilder}
     */

  }, {
    key: 'findById',
    value: function findById(id) {
      return this.whereComposite(this._modelClass.getFullIdColumn(), id).first();
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'withSchema',
    value: function withSchema(schema) {
      this.internalContext().onBuild.push(function (builder) {
        if (!builder.has(/withSchema/)) {
          // If the builder already has a schema, don't override it.
          builder.callKnexMethod('withSchema', [schema]);
        }
      });

      return this;
    }

    /**
     * @param {Object|Model|Array.<Object>|Array.<Model>} modelsOrObjects
     * @returns {QueryBuilder}
     */

  }, {
    key: 'insert',
    value: function insert(modelsOrObjects) {
      var ModelClass = this._modelClass;

      var insertion = new _InsertionOrUpdate2.default({
        ModelClass: ModelClass,
        modelsOrObjects: modelsOrObjects
      });

      this.$$callWriteMethodImpl('insert', [insertion, this]);

      this.runBefore(function (result, builder) {
        if (insertion.models().length > 1 && !(0, _dbUtils.isPostgres)(ModelClass.knex())) {
          throw new Error('batch insert only works with Postgresql');
        } else {
          return _bluebird2.default.map(insertion.models(), function (model) {
            return model.$beforeInsert(builder.context());
          });
        }
      });

      this.onBuild(function (builder) {
        if (!builder.has(/returning/)) {
          // If the user hasn't specified a `returning` clause, we make sure
          // that at least the identifier is returned.
          builder.returning(ModelClass.idColumn);
        }
      });

      this.runAfterModelCreatePushFront(function (ret) {
        if (!_lodash2.default.isArray(ret) || _lodash2.default.isEmpty(ret)) {
          // Early exit if there is nothing to do.
          return insertion.models();
        }

        // If the user specified a `returning` clause the result may already bean array of objects.
        if (_lodash2.default.all(ret, _lodash2.default.isObject)) {
          _lodash2.default.forEach(insertion.models(), function (model, index) {
            model.$set(ret[index]);
          });
        } else {
          // If the return value is not an array of objects, we assume it is an array of identifiers.
          _lodash2.default.forEach(insertion.models(), function (model, idx) {
            // Don't set the id if the model already has one. MySQL and Sqlite don't return the correct
            // primary key value if the id is not generated in db, but given explicitly.
            if (!model.$id()) {
              model.$id(ret[idx]);
            }
          });
        }

        return insertion.models();
      });

      this.runAfterModelCreate(function (models, builder) {
        return _bluebird2.default.map(models, function (model) {
          return model.$afterInsert(builder.context());
        }).then(function () {
          if (insertion.isArray()) {
            return models;
          } else {
            return models[0] || null;
          }
        });
      });

      return this;
    }

    /**
     * @param {Object|Model|Array.<Object>|Array.<Model>} modelsOrObjects
     * @returns {QueryBuilder}
     */

  }, {
    key: 'insertAndFetch',
    value: function insertAndFetch(modelsOrObjects) {
      var ModelClass = this._modelClass;

      return this.insert(modelsOrObjects).runAfterModelCreate(function (insertedModels, builder) {
        var insertedModelArray = _lodash2.default.isArray(insertedModels) ? insertedModels : [insertedModels];

        return ModelClass.query().childQueryOf(builder).whereInComposite(ModelClass.getFullIdColumn(), _lodash2.default.map(insertedModelArray, function (model) {
          return model.$id();
        })).then(function (fetchedModels) {
          fetchedModels = _lodash2.default.indexBy(fetchedModels, function (model) {
            return model.$id();
          });

          // Instead of returning the freshly fetched models, update the input
          // models with the fresh values.
          _lodash2.default.forEach(insertedModelArray, function (insertedModel) {
            insertedModel.$set(fetchedModels[insertedModel.$id()]);
          });

          return insertedModels;
        });
      });
    }

    /**
     * @param {Object|Model|Array.<Object>|Array.<Model>} modelsOrObjects
     * @returns {QueryBuilder}
     */

  }, {
    key: 'insertWithRelated',
    value: function insertWithRelated(modelsOrObjects) {
      var ModelClass = this._modelClass;
      var batchSize = (0, _dbUtils.isPostgres)(ModelClass.knex()) ? 100 : 1;

      var insertion = new _InsertionOrUpdate2.default({
        ModelClass: ModelClass,
        modelsOrObjects: modelsOrObjects,
        // We need to skip validation at this point because the models may contain
        // references and special properties. We validate the models upon insertion.
        modelOptions: { skipValidation: true }
      });

      this.$$callWriteMethodImpl('insert', [insertion, this]);

      // We resolve this query here and will not execute it. This is because the root
      // value may depend on other models in the graph and cannot be inserted first.
      this.resolve([]);

      this.runAfterModelCreatePushFront(function (result, builder) {
        var inserter = new _InsertWithRelated2.default({
          modelClass: ModelClass,
          models: insertion.models(),
          allowedRelations: builder._allowedInsertExpression || null
        });

        return inserter.execute(function (tableInsertion) {
          var insertQuery = tableInsertion.modelClass.query().childQueryOf(builder);

          // We skipped the validation above. We need to validate here since at this point
          // the models should no longer contain any special properties.
          _lodash2.default.forEach(tableInsertion.models, function (model) {
            model.$validate();
          });

          var inputs = _lodash2.default.filter(tableInsertion.models, function (model, idx) {
            return tableInsertion.isInputModel[idx];
          });

          var others = _lodash2.default.filter(tableInsertion.models, function (model, idx) {
            return !tableInsertion.isInputModel[idx];
          });

          return _bluebird2.default.all(_lodash2.default.flatten([batchInsert(inputs, insertQuery.clone().copyFrom(builder, /returning/), batchSize), batchInsert(others, insertQuery.clone(), batchSize)]));
        });
      });

      this.runAfterModelCreate(function (models) {
        if (insertion.isArray()) {
          return models;
        } else {
          return _lodash2.default.first(models) || null;
        }
      });
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: '$$insert',
    value: function $$insert(insertion) {
      var input = insertion;

      if (insertion instanceof _InsertionOrUpdate2.default) {
        insertion = insertion.models();
      }

      if (_lodash2.default.isArray(insertion)) {
        input = _lodash2.default.map(insertion, function (obj) {
          if (_lodash2.default.isFunction(obj.$toDatabaseJson)) {
            return obj.$toDatabaseJson();
          } else {
            return obj;
          }
        });
      } else if (_lodash2.default.isFunction(insertion.$toDatabaseJson)) {
        input = insertion.$toDatabaseJson();
      }

      return (0, _get4.default)((0, _getPrototypeOf2.default)(QueryBuilder.prototype), 'insert', this).call(this, input);
    }

    /**
     * @param {Model|Object=} modelOrObject
     * @returns {QueryBuilder}
     */

  }, {
    key: 'update',
    value: function update(modelOrObject) {
      return this.$$updateWithOptions(modelOrObject, 'update', {});
    }

    /**
     * @param {number|string|Array.<number|string>} id
     * @param {Model|Object=} modelOrObject
     * @returns {QueryBuilder}
     */

  }, {
    key: 'updateAndFetchById',
    value: function updateAndFetchById(id, modelOrObject) {
      return this.$$updateWithOptions(modelOrObject, 'update', {}, id).whereComposite(this._modelClass.getFullIdColumn(), id);
    }

    /**
     * @private
     */

  }, {
    key: '$$updateWithOptions',
    value: function $$updateWithOptions(modelOrObject, method, modelOptions, fetchId) {
      var ModelClass = this._modelClass;

      var update = new _InsertionOrUpdate2.default({
        ModelClass: ModelClass,
        modelOptions: modelOptions,
        modelsOrObjects: modelOrObject
      });

      this.$$callWriteMethodImpl(method, [update, this]);

      this.runBefore(function (result, builder) {
        return update.model().$beforeUpdate(modelOptions, builder.context());
      });

      this.runAfterModelCreate(function (numUpdated, builder) {
        var promise = undefined;

        if (fetchId) {
          promise = ModelClass.query().first().childQueryOf(builder).whereComposite(ModelClass.getFullIdColumn(), fetchId).then(function (model) {
            return model ? update.model().$set(model) : null;
          });
        } else {
          promise = _bluebird2.default.resolve(numUpdated);
        }

        return promise.then(function (result) {
          return [result, update.model().$afterUpdate(modelOptions, builder.context())];
        }).spread(function (result) {
          return result;
        });
      });

      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: '$$update',
    value: function $$update(update) {
      var input = update;
      var idColumn = this._modelClass.idColumn;

      if (update instanceof _InsertionOrUpdate2.default) {
        update = update.model();
      }

      if (_lodash2.default.isFunction(update.$toDatabaseJson)) {
        input = update.$toDatabaseJson();
      }

      // We never want to update the identifier.
      // TODO: Maybe we do?
      if (_lodash2.default.isArray(idColumn)) {
        _lodash2.default.each(idColumn, function (col) {
          delete input[col];
        });
      } else {
        delete input[idColumn];
      }

      return (0, _get4.default)((0, _getPrototypeOf2.default)(QueryBuilder.prototype), 'update', this).call(this, input);
    }

    /**
     * @param {Model|Object=} modelOrObject
     * @returns {QueryBuilder}
     */

  }, {
    key: 'patch',
    value: function patch(modelOrObject) {
      return this.$$updateWithOptions(modelOrObject, 'patch', { patch: true });
    }

    /**
     * @param {number|string|Array.<number|string>} id
     * @param {Model|Object=} modelOrObject
     * @returns {QueryBuilder}
     */

  }, {
    key: 'patchAndFetchById',
    value: function patchAndFetchById(id, modelOrObject) {
      return this.$$updateWithOptions(modelOrObject, 'patch', { patch: true }, id).whereComposite(this._modelClass.getFullIdColumn(), id);
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'delete',
    value: function _delete() {
      this.$$callWriteMethodImpl('delete', [this]);
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'del',
    value: function del() {
      return this.delete();
    }

    /**
     * @param {number|string|Array.<number|string>} id
     * @returns {QueryBuilder}
     */

  }, {
    key: 'deleteById',
    value: function deleteById(id) {
      return this.delete().whereComposite(this._modelClass.getFullIdColumn(), id);
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: '$$delete',
    value: function $$delete() {
      return (0, _get4.default)((0, _getPrototypeOf2.default)(QueryBuilder.prototype), 'delete', this).call(this);
    }

    /**
     * @param {number|string|object|Array.<number|string>|Array.<Array.<number|string>>|Array.<object>} ids
     * @returns {QueryBuilder}
     */

  }, {
    key: 'relate',
    value: function relate(ids) {
      this.$$callWriteMethodImpl('relate', [ids, this]);
      return this.runAfterModelCreate(function () {
        return ids;
      });
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'unrelate',
    value: function unrelate() {
      this.$$callWriteMethodImpl('unrelate', [this]);
      this.runAfterModelCreate(function () {
        return {};
      });
      return this;
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'increment',
    value: function increment(propertyName, howMuch) {
      var patch = {};
      var columnName = this._modelClass.propertyNameToColumnName(propertyName);
      patch[propertyName] = this._modelClass.knex().raw('?? + ?', [columnName, howMuch]);
      return this.patch(patch);
    }

    /**
     * @returns {QueryBuilder}
     */

  }, {
    key: 'decrement',
    value: function decrement(propertyName, howMuch) {
      var patch = {};
      var columnName = this._modelClass.propertyNameToColumnName(propertyName);
      patch[propertyName] = this._modelClass.knex().raw('?? - ?', [columnName, howMuch]);
      return this.patch(patch);
    }

    /**
     * @private
     */

  }, {
    key: '$$callWriteMethodImpl',
    value: function $$callWriteMethodImpl(method, args) {
      this._calledWriteMethod = 'method';
      return this._customImpl[method].apply(this, args);
    }
  }], [{
    key: 'forClass',
    value: function forClass(modelClass) {
      return new this(modelClass);
    }
  }]);
  return QueryBuilder;
}(_QueryBuilderBase3.default), (_applyDecoratedDescriptor(_class.prototype, 'dumpSql', [_dec], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'dumpSql'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'insert', [writeQueryMethod], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'insert'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'insertWithRelated', [writeQueryMethod], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'insertWithRelated'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, '$$updateWithOptions', [writeQueryMethod], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, '$$updateWithOptions'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'delete', [writeQueryMethod], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'delete'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'relate', [writeQueryMethod], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'relate'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'unrelate', [writeQueryMethod], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'unrelate'), _class.prototype)), _class));
exports.default = QueryBuilder;

function writeQueryMethod(target, property, descriptor) {
  descriptor.value = tryCallWriteMethod(descriptor.value);
}

function tryCallWriteMethod(func) {
  return function () {
    if (this._calledWriteMethod) {
      this.reject(new Error('Double call to a write method. ' + 'You can only call one of the write methods ' + '(insert, update, patch, delete, relate, unrelate, increment, decrement) ' + 'and only once per query builder.'));
      return this;
    }

    try {
      func.apply(this, arguments);
    } catch (err) {
      this.reject(err);
    }

    return this;
  };
}

function checkEager(builder) {
  if (builder._eagerExpression && builder._allowedEagerExpression) {
    if (!builder._allowedEagerExpression.isSubExpression(builder._eagerExpression)) {
      builder.reject(new _ValidationError2.default({ eager: 'eager expression not allowed' }));
    }
  }
}

function createModels(builder, result) {
  if (_lodash2.default.isNull(result) || _lodash2.default.isUndefined(result)) {
    return null;
  }

  if (_lodash2.default.isArray(result)) {
    if (result.length > 0 && _lodash2.default.isObject(result[0])) {
      for (var i = 0, l = result.length; i < l; ++i) {
        result[i] = builder._modelClass.fromDatabaseJson(result[i]);
      }
    }
  } else if (_lodash2.default.isObject(result)) {
    result = builder._modelClass.fromDatabaseJson(result);
  }

  return result;
}

function eagerFetch(builder, $models) {
  if ($models instanceof builder._modelClass || _lodash2.default.isArray($models) && $models[0] instanceof builder._modelClass) {
    var _ret = function () {
      var expression = builder._eagerExpression.clone();
      var filters = _lodash2.default.clone(builder._eagerFilters || {});

      _lodash2.default.each(builder._eagerFilterExpressions, function (filter, idx) {
        var filterNodes = expression.expressionsAtPath(filter.path);

        if (!_lodash2.default.isEmpty(filterNodes)) {
          (function () {
            var filterName = '_efe' + idx + '_';
            filters[filterName] = filter.filter;
            _lodash2.default.each(filterNodes, function (node) {
              return node.args.push(filterName);
            });
          })();
        }
      });

      return {
        v: new _EagerFetcher2.default({
          modelClass: builder._modelClass,
          models: builder._modelClass.ensureModelArray($models),
          eager: expression,
          filters: filters,
          rootQuery: builder
        }).fetch().then(function (models) {
          return _lodash2.default.isArray($models) ? models : models[0];
        })
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
  } else {
    return $models;
  }
}

function _build(builder) {
  var context = builder.context() || {};
  var internalContext = builder.internalContext();

  if (!builder.has(/from|table|into/)) {
    // Set the table only if it hasn't been explicitly set yet.
    builder.table(builder._modelClass.tableName);
  }

  callBuilderFuncs(builder, context.onBuild);
  callBuilderFuncs(builder, internalContext.onBuild);
  callBuilderFuncs(builder, builder._hooks.onBuild);

  // noinspection JSUnresolvedVariable
  return _QueryBuilderBase3.default.prototype.build.call(builder);
}

function batchInsert(models, queryBuilder, batchSize) {
  var batches = _lodash2.default.chunk(models, batchSize);
  return _lodash2.default.map(batches, function (batch) {
    return queryBuilder.clone().insert(batch);
  });
}

function callBuilderFuncs(builder, func) {
  if (_lodash2.default.isFunction(func)) {
    func.call(builder, builder);
  } else if (_lodash2.default.isArray(func)) {
    _lodash2.default.each(func, function (func) {
      func.call(builder, builder);
    });
  }
}

function chainBuilderFuncs(promise, builder, func) {
  if (_lodash2.default.isFunction(func)) {
    promise = promise.then(function (result) {
      return func.call(builder, result, builder);
    });
  } else if (_lodash2.default.isArray(func)) {
    _lodash2.default.each(func, function (func) {
      promise = promise.then(function (result) {
        return func.call(builder, result, builder);
      });
    });
  }

  return promise;
}