'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createHiddenDataGetter = createHiddenDataGetter;
exports.createHiddenDataSetter = createHiddenDataSetter;
var HIDDEN_DATA = '$$hiddenData';

function createHiddenDataGetter(propName) {
  return new Function('obj', '\n    return obj.' + HIDDEN_DATA + ' && obj.' + HIDDEN_DATA + '.' + propName + ';\n  ');
}

function createHiddenDataSetter(propName) {
  return new Function('obj', 'data', '\n    var hiddenData = obj.' + HIDDEN_DATA + ';\n\n    if (typeof hiddenData !== \'object\') {\n      hiddenData = Object.create(null);\n\n      Object.defineProperty(obj, "' + HIDDEN_DATA + '", {\n        enumerable: false,\n        writable: false,\n        value: hiddenData\n      });\n    }\n\n    hiddenData.' + propName + ' = data;\n  ');
}